diff --git a/include/linux/tcp.h b/include/linux/tcp.h
index 7c3bf08..9459dec 100644
--- a/include/linux/tcp.h
+++ b/include/linux/tcp.h
@@ -21,6 +21,41 @@
 #include <asm/byteorder.h>
 #include <linux/socket.h>
 
+struct tcphdr_unaligned {
+	__be16	source;
+	__be16	dest;
+	__be32	seq;
+	__be32	ack_seq;
+#if defined(__LITTLE_ENDIAN_BITFIELD)
+	__u8	res1:4,
+		doff:4,
+	__u8	fin:1,
+		syn:1,
+		rst:1,
+		psh:1,
+		ack:1,
+		urg:1,
+		ece:1,
+		cwr:1;
+#elif defined(__BIG_ENDIAN_BITFIELD)
+	__u8	doff:4,
+		res1:4,
+	__u8	cwr:1,
+		ece:1,
+		urg:1,
+		ack:1,
+		psh:1,
+		rst:1,
+		syn:1,
+		fin:1;
+#else
+#error	"Adjust your <asm/byteorder.h> defines"
+#endif	
+	__be16	window;
+	__sum16	check;
+	__be16	urg_ptr;
+} __packed;
+
 struct tcphdr {
 	__be16	source;
 	__be16	dest;
